/*******************************************************************************
** CGame.CPP
** Neverland Ranch
** 11/27/2003
** This is the class that manages it all.
*******************************************************************************/

// Include relevant files.
#include "CGame.h"
#include <iostream>
using namespace std;

// *structors.
CGame::CGame()
{
	init();
}

CGame::~CGame()
{
	term();
}

// Initialize The Game.
int CGame::init()
{
	mWorld.clear();

	CRoom *room = mWorld.addRoom("lobby", "You have entered the lobby.", "Situated in the corner of the lobby are a flight of [stairs] leading up to what appears to be a balcony of some sort. Along the front wall is a [door].");

	room->addLink("stairs", "balcony");
	room->addLink("door", "frontporch");

	room = mWorld.addRoom("balcony", "You have entered the balcony", "It overlooks the lobby. A flight of [stairs] off to the side lead down to the lobby. Through a small [window], you can see the yard out front.");
	room->addLink("stairs", "lobby");
	room->addLink("window", "frontporch");

	room = mWorld.addRoom("frontporch", "a scenic front porch", "it has a [door] leading inside");
	room->addLink("door", "lobby");

	return(0);
}

// Actually run The Game.
int CGame::run()
{
	string cmd, arg1, arg2, arg3;

	mPlayer.setCurRoom("frontporch");

	cout << "\n" << mWorld.getRoom("frontporch")->getDesc()
		 << endl;

	// Command proc.
	while(1)
	{
		cin >> cmd;

		// Help command
		if(cmd == "help")
		{
			// List all commands
				  // 80 characters:
				  // ----+----*----+----*----+----*----+----*----+----*----+----*----+----*----+----*
			cout << "\nCommand list:\n"
				 << "help                   :: Prints a list of all game commands.\n"
				 << "exit                   :: Exits the game.\n"
				 << "go <where>             :: Allows movement to specified destination.\n"
				 << "look                   :: Performs a detailed inspection of the current room.\n"
				 << "examine <item>         :: Examines an item in the current room.\n"
				 << endl;
		}
		// Quit command. Arguments: None.
		else if( (cmd == "exit") || (cmd == "quit") )
		{
			exit(0);
		}
		// Move command. Arguments: Destination.
		else if( (cmd == "go") || (cmd == "move"))
		{
			cin >> arg1;

			CRoom *room = mWorld.getRoom(mPlayer.getCurRoom());
			if(room)
			{
				arg1 = room->getLink(arg1);
				room = mWorld.getRoom(arg1);
				if(room)
				{
					mPlayer.setCurRoom(room->getName());

					cout << "\n" << room->getDesc()
						 << endl;

					continue;
				}
			}

			cout << "\nUnknown destination." << endl;
		}
		// Look. Performs a detailed inspection of the current room.
		else if( (cmd == "look") )
		{
			CRoom *room = mWorld.getRoom(mPlayer.getCurRoom());
			if(room)
			{
				cout << "\n" << room->getDetails()
					 << endl;
			}
		}
		// Examine. Arguments: Item to examine.
		else if( (cmd == "examine") || (cmd == "inspect") )
		{
		}
	}

	return(0);
}

// Terminates and cleans up The Game.
void CGame::term()
{
}