/*******************************************************************************
** CGame.H
** Neverland Ranch
** 11/27/2003
** This is the class that manages it all.
*******************************************************************************/

// Prevent multiple inclusions.
#ifndef H_CGAME_H
#define H_CGAME_H

// Include relevant files.
#include "CWorld.h"
#include "CPlayer.h"

// Standard library stuff.
#include <vector>
#include <string>

// Forward class decelerations.
class CWorld;
class CPlayer;
class CRoom;

// The Game class.
class CGame
{
public:
	// *structors.
	CGame();
	~CGame();

	// Initialize The Game.
	int									init();
	
	// Actually run The Game.
	int									run();

	// Terminates and cleans up The Game.
	void								term();

private:
	// The Player.
	CPlayer								mPlayer;

	// The World.
	CWorld								mWorld;

};

#endif // H_CGAME_H