/*******************************************************************************
** CPlayer.H
** Neverland Ranch
** 11/27/2003
** Class representing the Player in the World.
*******************************************************************************/

// Prevent multiple inclusions.
#ifndef H_CPLAYER_H
#define H_CPLAYER_H

// Include relevant files.

// Standard library stuff.
#include <vector>
#include <string>

// Forward class decelerations.
class CObject;

// The Player class.
class CPlayer
{
public:
	// *structors.
	CPlayer();
	CPlayer(std::string name);
	~CPlayer();

	// Room management.
	void								setCurRoom(std::string room);
	std::string							getCurRoom() { return mCurRoom; }

private:
	// Player's name.
	std::string							mName;

	// Room player is currently in (by name).
	std::string							mCurRoom;
};

#endif // H_CPLAYER_H