/*******************************************************************************
** CRoom.CPP
** Neverland Ranch
** 11/27/2003
** Class representing a 'Room' in the World.
*******************************************************************************/

// Include relevant files.
#include <iostream>
#include "CRoom.h"
using namespace std;

// *structors.
CRoom::CRoom(string name, string desc, string details)
{
	mName = name;
	mDesc = desc;
	mDetails = details;

	mLinks.clear();
}

CRoom::~CRoom()
{
	// Eliminate links.
	mLinks.clear();
}

// Adds a link.
int CRoom::addLink(string cmd, string rmName)
{
	// Validate.
	if( (cmd.empty()) || (rmName.empty()) )
		return(1);

	// Check for duplicates.
	for(int i=0;i<(int)mLinks.size();++i)
	{
		if(mLinks[i].mCmd == cmd)
		{
			cout << "\n*** CROOM WARNING *** Attempted to add duplicate linkage from '"
				 << mName << "' to '"
				 << rmName << "' via command '"
				 << cmd << ".'"
				 << endl;

			// Update anyways...
			mLinks[i].mCmd = cmd;
			mLinks[i].mRmName = rmName;
		}
	}

	// No duplicates found. Add a new link.
	SRoomLink link;
	link.mCmd = cmd;
	link.mRmName = rmName;

	mLinks.push_back(link);

	// Return success.
	return(0);
}

// Gets a linked Room by Command.
string CRoom::getLink(std::string cmd)
{
	// Traverse and find.
	for(int i=0;i<(int)mLinks.size();++i)
		if(mLinks[i].mCmd == cmd)
			return mLinks[i].mRmName;

	// Not found. Return empty string.
	return "";
}