/*******************************************************************************
** CWorld.CPP
** Neverland Ranch
** 11/27/2003
** This is the class that manages the world and its contents.
*******************************************************************************/

// Include relevant files.
#include <iostream>
#include "CWorld.h"
using namespace std;


// *structors.
CWorld::CWorld()
{
	clear();
}

CWorld::~CWorld()
{
	// Destroy all Rooms.
	clear();
}

// Adds a Room to the World. Returns resulting Room (if creation
// was successful).
CRoom *CWorld::addRoom(string name, string desc, string detail)
{
	// Validate params.
	if( (name.empty()) || (desc.empty()) || (detail.empty()) )
		return(NULL);

	// Check for duplicates.
	for(int i=0;i<(int)mRooms.size();++i)
	{
		if(mRooms[i].getName() == name)
		{
			// Print warning.
			cout << "\n*** CWORLD WARNING *** Attempted to add duplicate Room '"
				 << name << ".'"
				 << endl;

			// Return existing room.
			return &(mRooms[i]);
		}
	}

	// No duplicates. Create a new Room.
	CRoom room(name, desc, detail);
	mRooms.push_back(room);

	return &(mRooms.back());
}

// Gets a Room by name. Returned pointer validity can not be
// guaranteed after calling function terminates.
CRoom *CWorld::getRoom(string name)
{
	// Find it.
	for(int i=0;i<(int)mRooms.size();++i)
		if(mRooms[i].getName() == name)
			return &(mRooms[i]);

	// Not found.
	return(NULL);
}