/*******************************************************************************
** CWorld.H
** Neverland Ranch
** 11/27/2003
** This is the class that manages the world and its contents.
*******************************************************************************/

// Prevent multiple inclusions.
#ifndef H_CWORLD_H
#define H_CWORLD_H

// Include relevant files.
#include "CRoom.h"
#include "CPlayer.h"

// Standard library stuff.
#include <vector>
#include <string>

// Forward class decelerations.
class CPlayer;
class CRoom;

// The World class.
class CWorld
{
public:
	// *structors.
	CWorld();
	~CWorld();

	// Adds a Room to the World. Returns resulting Room (if creation
	// was successful).
	CRoom								*addRoom(std::string name,
												 std::string desc,
												 std::string detail);

	// Gets a Room by name. Returned pointer validity can not be
	// guaranteed after calling function terminates.
	CRoom								*getRoom(std::string name);

	void								clear() { mRooms.clear(); }

private:
	// Vector of all Rooms in this World.
	std::vector<CRoom>					mRooms;

};

#endif // H_CWORLD_H